import {GameModel} from "../GameModel";
import {LoadedProject} from "../../../../app/LoadedProject";
import {LoadModel} from "../../../../app/LoadModel";
import {ModelComponentType} from "../ModelComponentType";
import {ScriptAccount} from "../scriptAccounts/ScriptAccount";

export class ProcessLoadedProject {

  static processLoadedProject(loadedProject: LoadedProject): GameModel {
    const gameModel = new GameModel(loadedProject.projectName);
    loadedProject.loadedModels.forEach(loadedModel => this.processLoadedModel(gameModel, loadedModel))
    return gameModel;
  }

  static processLoadedModel(gameModel: GameModel, loadedModel: LoadModel) {
    switch (loadedModel.modelType) {
      case ModelComponentType.SCRIPTACCOUNT: this.processLoadedScriptAccount(gameModel, loadedModel); break;
      case ModelComponentType.GAMESYTEM: this.processLoadedGamesystem(gameModel, loadedModel); break;
    }
  }
  static processLoadedScriptAccount(gameModel: GameModel, loadedModel: LoadModel) {
    const scriptAccount = new ScriptAccount("", "");
    Object.assign(scriptAccount, JSON.parse(loadedModel.jsonString));
    gameModel.addScriptAccount(scriptAccount);
  }

  static processLoadedGamesystem(gameModel: GameModel, loadedModel: LoadModel) {

  }
}
